/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.296 Revision 1.366
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.296 2008/02/13 20:50:06 wolf31o2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.366 2011/09/30 16:51:01 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
17 17
18inherit multilib portability 18inherit multilib portability
19 19
20DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
21 21
22if has "${EAPI:-0}" 0 1 2; then
23
22# @FUNCTION: epause 24# @FUNCTION: epause
23# @USAGE: [seconds] 25# @USAGE: [seconds]
24# @DESCRIPTION: 26# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 28# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 30# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 31epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 33}
32 34
33# @FUNCTION: ebeep 35# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 36# @USAGE: [number of beeps]
35# @DESCRIPTION: 37# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 38# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 39# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 41# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 42ebeep() {
41 local n 43 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 46 echo -ne "\a"
47 sleep 1 49 sleep 1
48 done 50 done
49 fi 51 fi
50} 52}
51 53
52# Default directory where patches are located 54else
55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 }
76fi
77
78# @FUNCTION: ecvs_clean
79# @USAGE: [list of dirs]
80# @DESCRIPTION:
81# Remove CVS directories recursiveley. Useful when a source tarball contains
82# internal CVS directories. Defaults to $PWD.
83ecvs_clean() {
84 [[ -z $* ]] && set -- .
85 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
86 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
87}
88
89# @FUNCTION: esvn_clean
90# @USAGE: [list of dirs]
91# @DESCRIPTION:
92# Remove .svn directories recursiveley. Useful when a source tarball contains
93# internal Subversion directories. Defaults to $PWD.
94esvn_clean() {
95 [[ -z $* ]] && set -- .
96 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
97}
98
99# @FUNCTION: eshopts_push
100# @USAGE: [options to `set` or `shopt`]
101# @DESCRIPTION:
102# Often times code will want to enable a shell option to change code behavior.
103# Since changing shell options can easily break other pieces of code (which
104# assume the default state), eshopts_push is used to (1) push the current shell
105# options onto a stack and (2) pass the specified arguments to set.
106#
107# If the first argument is '-s' or '-u', we assume you want to call `shopt`
108# rather than `set` as there are some options only available via that.
109#
110# A common example is to disable shell globbing so that special meaning/care
111# may be used with variables/arguments to custom functions. That would be:
112# @CODE
113# eshopts_push -o noglob
114# for x in ${foo} ; do
115# if ...some check... ; then
116# eshopts_pop
117# return 0
118# fi
119# done
120# eshopts_pop
121# @CODE
122eshopts_push() {
123 # have to assume __ESHOPTS_SAVE__ isn't screwed with
124 # as a `declare -a` here will reset its value
125 local i=${#__ESHOPTS_SAVE__[@]}
126 if [[ $1 == -[su] ]] ; then
127 __ESHOPTS_SAVE__[$i]=$(shopt -p)
128 [[ $# -eq 0 ]] && return 0
129 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
130 else
131 __ESHOPTS_SAVE__[$i]=$-
132 [[ $# -eq 0 ]] && return 0
133 set "$@" || die "eshopts_push: bad options to set: $*"
134 fi
135}
136
137# @FUNCTION: eshopts_pop
138# @USAGE:
139# @DESCRIPTION:
140# Restore the shell options to the state saved with the corresponding
141# eshopts_push call. See that function for more details.
142eshopts_pop() {
143 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
144 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
145 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
146 local s=${__ESHOPTS_SAVE__[$i]}
147 unset __ESHOPTS_SAVE__[$i]
148 if [[ ${s} == "shopt -"* ]] ; then
149 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
150 else
151 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
152 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
153 fi
154}
155
156# @VARIABLE: EPATCH_SOURCE
157# @DESCRIPTION:
158# Default directory to search for patches.
53EPATCH_SOURCE="${WORKDIR}/patch" 159EPATCH_SOURCE="${WORKDIR}/patch"
54# Default extension for patches 160# @VARIABLE: EPATCH_SUFFIX
161# @DESCRIPTION:
162# Default extension for patches (do not prefix the period yourself).
55EPATCH_SUFFIX="patch.bz2" 163EPATCH_SUFFIX="patch.bz2"
164# @VARIABLE: EPATCH_OPTS
165# @DESCRIPTION:
56# Default options for patch 166# Default options for patch:
167# @CODE
57# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 168# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
58# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 169# --no-backup-if-mismatch - do not leave .orig files behind
59# Set -E to automatically remove empty files. 170# -E - automatically remove empty files
171# @CODE
60EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 172EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
173# @VARIABLE: EPATCH_EXCLUDE
174# @DESCRIPTION:
61# List of patches not to apply. Not this is only file names, 175# List of patches not to apply. Note this is only file names,
62# and not the full path .. 176# and not the full path. Globs accepted.
63EPATCH_EXCLUDE="" 177EPATCH_EXCLUDE=""
178# @VARIABLE: EPATCH_SINGLE_MSG
179# @DESCRIPTION:
64# Change the printed message for a single patch. 180# Change the printed message for a single patch.
65EPATCH_SINGLE_MSG="" 181EPATCH_SINGLE_MSG=""
182# @VARIABLE: EPATCH_MULTI_MSG
183# @DESCRIPTION:
66# Change the printed message for multiple patches. 184# Change the printed message for multiple patches.
67EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 185EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
68# Force applying bulk patches even if not following the style: 186# @VARIABLE: EPATCH_FORCE
69# 187# @DESCRIPTION:
70# ??_${ARCH}_foo.${EPATCH_SUFFIX} 188# Only require patches to match EPATCH_SUFFIX rather than the extended
71# 189# arch naming style.
72EPATCH_FORCE="no" 190EPATCH_FORCE="no"
73 191
74# This function is for bulk patching, or in theory for just one 192# @FUNCTION: epatch
75# or two patches. 193# @USAGE: [patches] [dirs of patches]
194# @DESCRIPTION:
195# epatch is designed to greatly simplify the application of patches. It can
196# process patch files directly, or directories of patches. The patches may be
197# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
198# the -p option as epatch will automatically attempt -p0 to -p5 until things
199# apply successfully.
76# 200#
77# It should work with .bz2, .gz, .zip and plain text patches. 201# If you do not specify any options, then epatch will default to the directory
78# Currently all patches should be the same format. 202# specified by EPATCH_SOURCE.
79# 203#
80# You do not have to specify '-p' option to patch, as it will 204# When processing directories, epatch will apply all patches that match:
81# try with -p0 to -p5 until it succeed, or fail at -p5. 205# @CODE
82# 206# if ${EPATCH_FORCE} != "yes"
83# Above EPATCH_* variables can be used to control various defaults,
84# bug they should be left as is to ensure an ebuild can rely on
85# them for.
86#
87# Patches are applied in current directory.
88#
89# Bulk Patches should preferibly have the form of:
90#
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
208# else
209# *.${EPATCH_SUFFIX}
210# @CODE
211# The leading ?? are typically numbers used to force consistent patch ordering.
212# The arch field is used to apply patches only for the host architecture with
213# the special value of "all" means apply for everyone. Note that using values
214# other than "all" is highly discouraged -- you should apply patches all the
215# time and let architecture details be detected at configure/compile time.
92# 216#
93# For example: 217# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
218# for patches to apply.
94# 219#
95# 01_all_misc-fix.patch.bz2 220# Refer to the other EPATCH_xxx variables for more customization of behavior.
96# 02_sparc_another-fix.patch.bz2
97#
98# This ensures that there are a set order, and you can have ARCH
99# specific patches.
100#
101# If you however give an argument to epatch(), it will treat it as a
102# single patch that need to be applied if its a file. If on the other
103# hand its a directory, it will set EPATCH_SOURCE to this.
104#
105# <azarah@gentoo.org> (10 Nov 2002)
106#
107epatch() { 221epatch() {
108 _epatch_draw_line() { 222 _epatch_draw_line() {
223 # create a line of same length as input string
109 [[ -z $1 ]] && set "$(printf "%65s" '')" 224 [[ -z $1 ]] && set "$(printf "%65s" '')"
110 echo "${1//?/=}" 225 echo "${1//?/=}"
111 } 226 }
112 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
113 local PIPE_CMD=""
114 local STDERR_TARGET="${T}/$$.out"
115 local PATCH_TARGET="${T}/$$.patch"
116 local PATCH_SUFFIX=""
117 local SINGLE_PATCH="no"
118 local x=""
119 227
120 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 228 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
121 229
122 if [ "$#" -gt 1 ] 230 # Let the rest of the code process one user arg at a time --
123 then 231 # each arg may expand into multiple patches, and each arg may
232 # need to start off with the default global EPATCH_xxx values
233 if [[ $# -gt 1 ]] ; then
124 local m="" 234 local m
125 for m in "$@" ; do 235 for m in "$@" ; do
126 epatch "${m}" 236 epatch "${m}"
127 done 237 done
128 return 0 238 return 0
129 fi 239 fi
130 240
131 if [ -n "$1" -a -f "$1" ] 241 local SINGLE_PATCH="no"
132 then 242 # no args means process ${EPATCH_SOURCE}
243 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
244
245 if [[ -f $1 ]] ; then
133 SINGLE_PATCH="yes" 246 SINGLE_PATCH="yes"
134 247 set -- "$1"
135 local EPATCH_SOURCE="$1" 248 # Use the suffix from the single patch (localize it); the code
249 # below will find the suffix for us
136 local EPATCH_SUFFIX="${1##*\.}" 250 local EPATCH_SUFFIX=$1
137 251
138 elif [ -n "$1" -a -d "$1" ] 252 elif [[ -d $1 ]] ; then
139 then 253 # Some people like to make dirs of patches w/out suffixes (vim)
140 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
141 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
260
261 else
262 # sanity check ... if it isn't a dir or file, wtf man ?
263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
264 echo
265 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
266 eerror
267 eerror " ${EPATCH_SOURCE}"
268 eerror " ( ${EPATCH_SOURCE##*/} )"
269 echo
270 die "Cannot find \$EPATCH_SOURCE!"
271 fi
272
273 local PIPE_CMD
274 case ${EPATCH_SUFFIX##*\.} in
275 xz) PIPE_CMD="xz -dc" ;;
276 lzma) PIPE_CMD="lzma -dc" ;;
277 bz2) PIPE_CMD="bzip2 -dc" ;;
278 gz|Z|z) PIPE_CMD="gzip -dc" ;;
279 ZIP|zip) PIPE_CMD="unzip -p" ;;
280 *) ;;
281 esac
282
283 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
284
285 local x
286 for x in "$@" ; do
287 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
288 # didn't match anything, ignore continue on
289 [[ ! -f ${x} ]] && continue
290
291 local patchname=${x##*/}
292
293 # Apply single patches, or forced sets of patches, or
294 # patches with ARCH dependant names.
295 # ???_arch_foo.patch
296 # Else, skip this input altogether
297 local a=${patchname#*_} # strip the ???_
298 a=${a%%_*} # strip the _foo.patch
299 if ! [[ ${SINGLE_PATCH} == "yes" || \
300 ${EPATCH_FORCE} == "yes" || \
301 ${a} == all || \
302 ${a} == ${ARCH} ]]
142 then 303 then
143 local EPATCH_SOURCE="$1/*" 304 continue
305 fi
306
307 # Let people filter things dynamically
308 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
309 # let people use globs in the exclude
310 eshopts_push -o noglob
311
312 local ex
313 for ex in ${EPATCH_EXCLUDE} ; do
314 if [[ ${patchname} == ${ex} ]] ; then
315 eshopts_pop
316 continue 2
317 fi
318 done
319
320 eshopts_pop
321 fi
322
323 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
324 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
325 einfo "${EPATCH_SINGLE_MSG}"
326 else
327 einfo "Applying ${patchname} ..."
328 fi
144 else 329 else
145 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 330 einfo " ${patchname} ..."
146 fi 331 fi
147 else 332
148 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 333 # most of the time, there will only be one run per unique name,
149 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 334 # but if there are more, make sure we get unique log filenames
150 then 335 local STDERR_TARGET="${T}/${patchname}.out"
151 EPATCH_SOURCE="$1" 336 if [[ -e ${STDERR_TARGET} ]] ; then
337 STDERR_TARGET="${T}/${patchname}-$$.out"
338 fi
339
340 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
341
342 # Decompress the patch if need be
343 local count=0
344 local PATCH_TARGET
345 if [[ -n ${PIPE_CMD} ]] ; then
346 PATCH_TARGET="${T}/$$.patch"
347 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
348
349 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
350 echo
351 eerror "Could not extract patch!"
352 #die "Could not extract patch!"
353 count=5
354 break
152 fi 355 fi
356 else
357 PATCH_TARGET=${x}
358 fi
153 359
360 # Check for absolute paths in patches. If sandbox is disabled,
361 # people could (accidently) patch files in the root filesystem.
362 # Or trigger other unpleasantries #237667. So disallow -p0 on
363 # such patches.
364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
365 if [[ -n ${abs_paths} ]] ; then
366 count=1
367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
376
377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
378 while [[ ${count} -lt 5 ]] ; do
379 # Generate some useful debug info ...
380 (
381 _epatch_draw_line "***** ${patchname} *****"
154 echo 382 echo
155 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
384 echo
385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
391 ) >> "${STDERR_TARGET}"
392
393 if [ $? -eq 0 ] ; then
394 (
395 _epatch_draw_line "***** ${patchname} *****"
396 echo
397 echo "ACTUALLY APPLYING ${patchname} ..."
398 echo
399 _epatch_draw_line "***** ${patchname} *****"
400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
405 ) >> "${STDERR_TARGET}"
406
407 if [ $? -ne 0 ] ; then
408 echo
409 eerror "A dry-run of patch command succeeded, but actually"
410 eerror "applying the patch failed!"
411 #die "Real world sux compared to the dreamworld!"
412 count=5
413 fi
414 break
415 fi
416
417 : $(( count++ ))
418 done
419
420 # if we had to decompress the patch, delete the temp one
421 if [[ -n ${PIPE_CMD} ]] ; then
422 rm -f "${PATCH_TARGET}"
423 fi
424
425 if [[ ${count} -ge 5 ]] ; then
426 echo
427 eerror "Failed Patch: ${patchname} !"
428 eerror " ( ${PATCH_TARGET} )"
156 eerror 429 eerror
157 eerror " ${EPATCH_SOURCE}" 430 eerror "Include in your bugreport the contents of:"
158 eerror " ( ${EPATCH_SOURCE##*/} )" 431 eerror
432 eerror " ${STDERR_TARGET}"
159 echo 433 echo
160 die "Cannot find \$EPATCH_SOURCE!"
161 fi
162
163 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
164 fi
165
166 case ${EPATCH_SUFFIX##*\.} in
167 bz2)
168 PIPE_CMD="bzip2 -dc"
169 PATCH_SUFFIX="bz2"
170 ;;
171 gz|Z|z)
172 PIPE_CMD="gzip -dc"
173 PATCH_SUFFIX="gz"
174 ;;
175 ZIP|zip)
176 PIPE_CMD="unzip -p"
177 PATCH_SUFFIX="zip"
178 ;;
179 *)
180 PIPE_CMD="cat"
181 PATCH_SUFFIX="patch"
182 ;;
183 esac
184
185 if [ "${SINGLE_PATCH}" = "no" ]
186 then
187 einfo "${EPATCH_MULTI_MSG}"
188 fi
189 for x in ${EPATCH_SOURCE}
190 do
191 # New ARCH dependant patch naming scheme ...
192 #
193 # ???_arch_foo.patch
194 #
195 if [ -f ${x} ] && \
196 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
197 [ "${EPATCH_FORCE}" = "yes" ])
198 then
199 local count=0
200 local popts="${EPATCH_OPTS}"
201 local patchname=${x##*/}
202
203 if [ -n "${EPATCH_EXCLUDE}" ]
204 then
205 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
206 then
207 continue
208 fi
209 fi
210
211 if [ "${SINGLE_PATCH}" = "yes" ]
212 then
213 if [ -n "${EPATCH_SINGLE_MSG}" ]
214 then
215 einfo "${EPATCH_SINGLE_MSG}"
216 else
217 einfo "Applying ${patchname} ..."
218 fi
219 else
220 einfo " ${patchname} ..."
221 fi
222
223 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
224 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
225
226 # Allow for prefix to differ ... im lazy, so shoot me :/
227 while [ "${count}" -lt 5 ]
228 do
229 # Generate some useful debug info ...
230 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
231 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
232
233 if [ "${PATCH_SUFFIX}" != "patch" ]
234 then
235 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
236 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
237 else
238 PATCH_TARGET="${x}"
239 fi
240
241 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
242 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
243
244 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
245 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246
247 if [ "${PATCH_SUFFIX}" != "patch" ]
248 then
249 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
250 then
251 echo
252 eerror "Could not extract patch!"
253 #die "Could not extract patch!"
254 count=5
255 break
256 fi
257 fi
258
259 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
260 then
261 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
263 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
264 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
265 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
266
267 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
268 _epatch_assert
269
270 if [ "$?" -ne 0 ]
271 then
272 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
273 echo
274 eerror "A dry-run of patch command succeeded, but actually"
275 eerror "applying the patch failed!"
276 #die "Real world sux compared to the dreamworld!"
277 count=5
278 fi
279
280 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
281
282 break
283 fi
284
285 count=$((count + 1))
286 done
287
288 if [ "${PATCH_SUFFIX}" != "patch" ]
289 then
290 rm -f ${PATCH_TARGET}
291 fi
292
293 if [ "${count}" -eq 5 ]
294 then
295 echo
296 eerror "Failed Patch: ${patchname} !"
297 eerror " ( ${PATCH_TARGET} )"
298 eerror
299 eerror "Include in your bugreport the contents of:"
300 eerror
301 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
302 echo
303 die "Failed Patch: ${patchname}!" 434 die "Failed Patch: ${patchname}!"
304 fi 435 fi
305 436
306 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 437 # if everything worked, delete the patch log
307 438 rm -f "${STDERR_TARGET}"
308 eend 0 439 eend 0
309 fi
310 done 440 done
311 if [ "${SINGLE_PATCH}" = "no" ] 441
312 then 442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
313 einfo "Done with patching" 443 : # everything worked
444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
472epatch_user() {
473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
478
479 # don't clobber any EPATCH vars that the parent might want
480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
483 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
485 if [[ -d ${EPATCH_SOURCE} ]] ; then
486 EPATCH_SOURCE=${EPATCH_SOURCE} \
487 EPATCH_SUFFIX="patch" \
488 EPATCH_FORCE="yes" \
489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
490 epatch
491 echo "${EPATCH_SOURCE}" > "${applied}"
492 return 0
314 fi 493 fi
494 done
495 echo "none" > "${applied}"
496 return 1
315} 497}
316 498
317# @FUNCTION: emktemp 499# @FUNCTION: emktemp
318# @USAGE: [temp dir] 500# @USAGE: [temp dir]
319# @DESCRIPTION: 501# @DESCRIPTION:
355# base-system@gentoo.org (Linux) 537# base-system@gentoo.org (Linux)
356# Joe Jezak <josejx@gmail.com> (OS X) 538# Joe Jezak <josejx@gmail.com> (OS X)
357# usata@gentoo.org (OS X) 539# usata@gentoo.org (OS X)
358# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD) 540# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
359# @DESCRIPTION: 541# @DESCRIPTION:
360# Small wrapper for getent (Linux), nidump (Mac OS X), 542# Small wrapper for getent (Linux),
543# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
361# and pw (FreeBSD) used in enewuser()/enewgroup() 544# and pw (FreeBSD) used in enewuser()/enewgroup()
362egetent() { 545egetent() {
363 case ${CHOST} in 546 case ${CHOST} in
364 *-darwin*) 547 *-darwin[678])
365 case "$2" in 548 case "$2" in
366 *[!0-9]*) # Non numeric 549 *[!0-9]*) # Non numeric
367 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 550 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
368 ;; 551 ;;
369 *) # Numeric 552 *) # Numeric
370 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 553 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
554 ;;
555 esac
556 ;;
557 *-darwin*)
558 local mytype=$1
559 [[ "passwd" == $mytype ]] && mytype="Users"
560 [[ "group" == $mytype ]] && mytype="Groups"
561 case "$2" in
562 *[!0-9]*) # Non numeric
563 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
564 ;;
565 *) # Numeric
566 local mykey="UniqueID"
567 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
568 dscl . -search /$mytype $mykey $2 2>/dev/null
371 ;; 569 ;;
372 esac 570 esac
373 ;; 571 ;;
374 *-freebsd*|*-dragonfly*) 572 *-freebsd*|*-dragonfly*)
375 local opts action="user" 573 local opts action="user"
575 fi 773 fi
576 ;; 774 ;;
577 775
578 *) 776 *)
579 if [[ -z $@ ]] ; then 777 if [[ -z $@ ]] ; then
580 useradd ${opts} ${euser} \ 778 useradd -r ${opts} \
581 -c "added by portage for ${PN}" \ 779 -c "added by portage for ${PN}" \
780 ${euser} \
582 || die "enewuser failed" 781 || die "enewuser failed"
583 else 782 else
584 einfo " - Extra: $@" 783 einfo " - Extra: $@"
585 useradd ${opts} ${euser} "$@" \ 784 useradd -r ${opts} "$@" \
785 ${euser} \
586 || die "enewuser failed" 786 || die "enewuser failed"
587 fi 787 fi
588 ;; 788 ;;
589 esac 789 esac
590 790
702 esac 902 esac
703 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 903 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
704 ;; 904 ;;
705 905
706 *) 906 *)
907 # We specify -r so that we get a GID in the system range from login.defs
707 groupadd ${opts} ${egroup} || die "enewgroup failed" 908 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
708 ;; 909 ;;
709 esac 910 esac
710 export SANDBOX_ON="${oldsandbox}" 911 export SANDBOX_ON="${oldsandbox}"
711} 912}
712 913
716# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 917# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
717# to remove all of these text utilities from DEPEND variables because this 918# to remove all of these text utilities from DEPEND variables because this
718# is a script based solution. Just give it a list of files to convert and 919# is a script based solution. Just give it a list of files to convert and
719# they will all be changed from the DOS CRLF format to the UNIX LF format. 920# they will all be changed from the DOS CRLF format to the UNIX LF format.
720edos2unix() { 921edos2unix() {
721 echo "$@" | xargs sed -i 's/\r$//' 922 [[ $# -eq 0 ]] && return 0
923 sed -i 's/\r$//' -- "$@" || die
722} 924}
723 925
724# Make a desktop file ! 926# Make a desktop file !
725# Great for making those icons in kde/gnome startmenu ! 927# Great for making those icons in kde/gnome startmenu !
726# Amaze your friends ! Get the women ! Join today ! 928# Amaze your friends ! Get the women ! Join today !
727# 929#
728# make_desktop_entry(<command>, [name], [icon], [type], [path]) 930# make_desktop_entry(<command>, [name], [icon], [type], [fields])
729# 931#
730# binary: what command does the app run with ? 932# binary: what command does the app run with ?
731# name: the name that will show up in the menu 933# name: the name that will show up in the menu
732# icon: give your little like a pretty little icon ... 934# icon: give your little like a pretty little icon ...
733# this can be relative (to /usr/share/pixmaps) or 935# this can be relative (to /usr/share/pixmaps) or
734# a full path to an icon 936# a full path to an icon
735# type: what kind of application is this ? for categories: 937# type: what kind of application is this ? for categories:
736# http://standards.freedesktop.org/menu-spec/latest/apa.html 938# http://standards.freedesktop.org/menu-spec/latest/apa.html
737# path: if your app needs to startup in a specific dir 939# fields: extra fields to append to the desktop file; a printf string
738make_desktop_entry() { 940make_desktop_entry() {
739 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 941 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
740 942
741 local exec=${1} 943 local exec=${1}
742 local name=${2:-${PN}} 944 local name=${2:-${PN}}
743 local icon=${3:-${PN}} 945 local icon=${3:-${PN}}
744 local type=${4} 946 local type=${4}
745 local path=${5} 947 local fields=${5}
746 948
747 if [[ -z ${type} ]] ; then 949 if [[ -z ${type} ]] ; then
748 local catmaj=${CATEGORY%%-*} 950 local catmaj=${CATEGORY%%-*}
749 local catmin=${CATEGORY##*-} 951 local catmin=${CATEGORY##*-}
750 case ${catmaj} in 952 case ${catmaj} in
751 app) 953 app)
752 case ${catmin} in 954 case ${catmin} in
753 accessibility) type=Accessibility;; 955 accessibility) type=Accessibility;;
754 admin) type=System;; 956 admin) type=System;;
755 antivirus) type=System;; 957 antivirus) type=System;;
756 arch) type=Archiving;; 958 arch) type=Archiving;;
757 backup) type=Archiving;; 959 backup) type=Archiving;;
758 cdr) type=DiscBurning;; 960 cdr) type=DiscBurning;;
759 dicts) type=Dictionary;; 961 dicts) type=Dictionary;;
760 doc) type=Documentation;; 962 doc) type=Documentation;;
761 editors) type=TextEditor;; 963 editors) type=TextEditor;;
762 emacs) type=TextEditor;; 964 emacs) type=TextEditor;;
763 emulation) type=Emulator;; 965 emulation) type=Emulator;;
764 laptop) type=HardwareSettings;; 966 laptop) type=HardwareSettings;;
765 office) type=Office;; 967 office) type=Office;;
766 pda) type=PDA;; 968 pda) type=PDA;;
767 vim) type=TextEditor;; 969 vim) type=TextEditor;;
768 xemacs) type=TextEditor;; 970 xemacs) type=TextEditor;;
769 *) type=;;
770 esac 971 esac
771 ;; 972 ;;
772 973
773 dev) 974 dev)
774 type="Development" 975 type="Development"
775 ;; 976 ;;
776 977
777 games) 978 games)
778 case ${catmin} in 979 case ${catmin} in
779 action|fps) type=ActionGame;; 980 action|fps) type=ActionGame;;
780 arcade) type=ArcadeGame;; 981 arcade) type=ArcadeGame;;
781 board) type=BoardGame;; 982 board) type=BoardGame;;
782 emulation) type=Emulator;; 983 emulation) type=Emulator;;
783 kids) type=KidsGame;; 984 kids) type=KidsGame;;
784 puzzle) type=LogicGame;; 985 puzzle) type=LogicGame;;
785 roguelike) type=RolePlaying;; 986 roguelike) type=RolePlaying;;
786 rpg) type=RolePlaying;; 987 rpg) type=RolePlaying;;
787 simulation) type=Simulation;; 988 simulation) type=Simulation;;
788 sports) type=SportsGame;; 989 sports) type=SportsGame;;
789 strategy) type=StrategyGame;; 990 strategy) type=StrategyGame;;
790 *) type=;;
791 esac 991 esac
792 type="Game;${type}" 992 type="Game;${type}"
793 ;; 993 ;;
794 994
795 gnome) 995 gnome)
804 type="Network;Email" 1004 type="Network;Email"
805 ;; 1005 ;;
806 1006
807 media) 1007 media)
808 case ${catmin} in 1008 case ${catmin} in
1009 gfx)
809 gfx) type=Graphics;; 1010 type=Graphics
1011 ;;
1012 *)
1013 case ${catmin} in
810 radio) type=Tuner;; 1014 radio) type=Tuner;;
811 sound) type=Audio;; 1015 sound) type=Audio;;
812 tv) type=TV;; 1016 tv) type=TV;;
813 video) type=Video;; 1017 video) type=Video;;
814 *) type=;; 1018 esac
1019 type="AudioVideo;${type}"
1020 ;;
815 esac 1021 esac
816 type="AudioVideo;${type}"
817 ;; 1022 ;;
818 1023
819 net) 1024 net)
820 case ${catmin} in 1025 case ${catmin} in
821 dialup) type=Dialup;; 1026 dialup) type=Dialup;;
822 ftp) type=FileTransfer;; 1027 ftp) type=FileTransfer;;
823 im) type=InstantMessaging;; 1028 im) type=InstantMessaging;;
824 irc) type=IRCClient;; 1029 irc) type=IRCClient;;
825 mail) type=Email;; 1030 mail) type=Email;;
826 news) type=News;; 1031 news) type=News;;
827 nntp) type=News;; 1032 nntp) type=News;;
828 p2p) type=FileTransfer;; 1033 p2p) type=FileTransfer;;
829 *) type=;; 1034 voip) type=Telephony;;
830 esac 1035 esac
831 type="Network;${type}" 1036 type="Network;${type}"
832 ;; 1037 ;;
833 1038
834 sci) 1039 sci)
835 case ${catmin} in 1040 case ${catmin} in
836 astro*) type=Astronomy;; 1041 astro*) type=Astronomy;;
837 bio*) type=Biology;; 1042 bio*) type=Biology;;
838 calc*) type=Calculator;; 1043 calc*) type=Calculator;;
839 chem*) type=Chemistry;; 1044 chem*) type=Chemistry;;
840 elec*) type=Electronics;; 1045 elec*) type=Electronics;;
841 geo*) type=Geology;; 1046 geo*) type=Geology;;
842 math*) type=Math;; 1047 math*) type=Math;;
843 physics) type=Physics;; 1048 physics) type=Physics;;
844 visual*) type=DataVisualization;; 1049 visual*) type=DataVisualization;;
845 *) type=;;
846 esac 1050 esac
847 type="Science;${type}" 1051 type="Education;Science;${type}"
848 ;; 1052 ;;
849 1053
850 sys) 1054 sys)
851 type="System" 1055 type="System"
852 ;; 1056 ;;
853 1057
854 www) 1058 www)
855 case ${catmin} in 1059 case ${catmin} in
856 client) type=WebBrowser;; 1060 client) type=WebBrowser;;
857 *) type=;;
858 esac 1061 esac
859 type="Network" 1062 type="Network;${type}"
860 ;; 1063 ;;
861 1064
862 *) 1065 *)
863 type= 1066 type=
864 ;; 1067 ;;
870 local desktop_name="${PN}-${SLOT}" 1073 local desktop_name="${PN}-${SLOT}"
871 fi 1074 fi
872 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 1075 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
873 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1076 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
874 1077
1078 # Don't append another ";" when a valid category value is provided.
1079 type=${type%;}${type:+;}
1080
1081 eshopts_push -s extglob
1082 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1083 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1084 ewarn "allowed in .desktop files if the value is not an absolute path."
1085 icon=${icon%.@(xpm|png|svg)}
1086 fi
1087 eshopts_pop
1088
875 cat <<-EOF > "${desktop}" 1089 cat <<-EOF > "${desktop}"
876 [Desktop Entry] 1090 [Desktop Entry]
877 Version=1.0
878 Name=${name} 1091 Name=${name}
879 Type=Application 1092 Type=Application
880 Comment=${DESCRIPTION} 1093 Comment=${DESCRIPTION}
881 Exec=${exec} 1094 Exec=${exec}
882 TryExec=${exec%% *} 1095 TryExec=${exec%% *}
883 Icon=${icon} 1096 Icon=${icon}
884 Categories=${type}; 1097 Categories=${type}
885 EOF 1098 EOF
886 1099
887 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 1100 if [[ ${fields:-=} != *=* ]] ; then
1101 # 5th arg used to be value to Path=
1102 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1103 fields="Path=${fields}"
1104 fi
1105 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
888 1106
889 ( 1107 (
890 # wrap the env here so that the 'insinto' call 1108 # wrap the env here so that the 'insinto' call
891 # doesn't corrupt the env of the caller 1109 # doesn't corrupt the env of the caller
892 insinto /usr/share/applications 1110 insinto /usr/share/applications
893 doins "${desktop}" 1111 doins "${desktop}"
894 ) 1112 ) || die "installing desktop file failed"
895} 1113}
896 1114
897# @FUNCTION: validate_desktop_entries 1115# @FUNCTION: validate_desktop_entries
898# @USAGE: [directories] 1116# @USAGE: [directories]
899# @MAINTAINER: 1117# @MAINTAINER:
921 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 1139 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
922 fi 1140 fi
923} 1141}
924 1142
925# @FUNCTION: make_session_desktop 1143# @FUNCTION: make_session_desktop
926# @USAGE: <title> <command> 1144# @USAGE: <title> <command> [command args...]
927# @DESCRIPTION: 1145# @DESCRIPTION:
928# Make a GDM/KDM Session file. The title is the file to execute to start the 1146# Make a GDM/KDM Session file. The title is the file to execute to start the
929# Window Manager. The command is the name of the Window Manager. 1147# Window Manager. The command is the name of the Window Manager.
1148#
1149# You can set the name of the file via the ${wm} variable.
930make_session_desktop() { 1150make_session_desktop() {
931 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1151 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
932 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1152 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
933 1153
934 local title=$1 1154 local title=$1
935 local command=$2 1155 local command=$2
936 local desktop=${T}/${wm}.desktop 1156 local desktop=${T}/${wm:-${PN}}.desktop
1157 shift 2
937 1158
938 cat <<-EOF > "${desktop}" 1159 cat <<-EOF > "${desktop}"
939 [Desktop Entry] 1160 [Desktop Entry]
940 Name=${title} 1161 Name=${title}
941 Comment=This session logs you into ${title} 1162 Comment=This session logs you into ${title}
942 Exec=${command} 1163 Exec=${command} $*
943 TryExec=${command} 1164 TryExec=${command}
944 Type=Application 1165 Type=XSession
945 EOF 1166 EOF
946 1167
947 ( 1168 (
948 # wrap the env here so that the 'insinto' call 1169 # wrap the env here so that the 'insinto' call
949 # doesn't corrupt the env of the caller 1170 # doesn't corrupt the env of the caller
1175 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1396 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1176 1397
1177 local shrtsrc=$(basename "${src}") 1398 local shrtsrc=$(basename "${src}")
1178 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1399 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1179 if [[ -z ${skip} ]] ; then 1400 if [[ -z ${skip} ]] ; then
1180 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1401 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1181 local skip=0 1402 local skip=0
1182 exe=tail 1403 exe=tail
1183 case ${ver} in 1404 case ${ver} in
1184 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1405 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1185 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1406 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1187 2.0|2.0.1) 1408 2.0|2.0.1)
1188 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1409 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1189 ;; 1410 ;;
1190 2.1.1) 1411 2.1.1)
1191 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1412 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1192 let skip="skip + 1" 1413 (( skip++ ))
1193 ;; 1414 ;;
1194 2.1.2) 1415 2.1.2)
1195 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1416 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1196 let skip="skip + 1" 1417 (( skip++ ))
1197 ;; 1418 ;;
1198 2.1.3) 1419 2.1.3)
1199 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1420 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1200 let skip="skip + 1" 1421 (( skip++ ))
1201 ;; 1422 ;;
1202 2.1.4|2.1.5) 1423 2.1.4|2.1.5)
1203 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1424 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1204 skip=$(head -n ${skip} "${src}" | wc -c) 1425 skip=$(head -n ${skip} "${src}" | wc -c)
1205 exe="dd" 1426 exe="dd"
1214 esac 1435 esac
1215 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1436 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1216 fi 1437 fi
1217 case ${exe} in 1438 case ${exe} in
1218 tail) exe="tail -n +${skip} '${src}'";; 1439 tail) exe="tail -n +${skip} '${src}'";;
1219 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1440 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1220 *) die "makeself cant handle exe '${exe}'" 1441 *) die "makeself cant handle exe '${exe}'"
1221 esac 1442 esac
1222 1443
1223 # lets grab the first few bytes of the file to figure out what kind of archive it is 1444 # lets grab the first few bytes of the file to figure out what kind of archive it is
1224 local tmpfile=$(emktemp) 1445 local filetype tmpfile=$(emktemp)
1225 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1446 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1226 local filetype=$(file -b "${tmpfile}") 1447 filetype=$(file -b "${tmpfile}") || die
1227 case ${filetype} in 1448 case ${filetype} in
1228 *tar\ archive*) 1449 *tar\ archive*)
1229 eval ${exe} | tar --no-same-owner -xf - 1450 eval ${exe} | tar --no-same-owner -xf -
1230 ;; 1451 ;;
1231 bzip2*) 1452 bzip2*)
1261 lic="${PWD}/${lic}" 1482 lic="${PWD}/${lic}"
1262 elif [ -e "${lic}" ] ; then 1483 elif [ -e "${lic}" ] ; then
1263 lic="${lic}" 1484 lic="${lic}"
1264 fi 1485 fi
1265 fi 1486 fi
1266 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1267 local l="`basename ${lic}`" 1487 local l="`basename ${lic}`"
1268 1488
1269 # here is where we check for the licenses the user already 1489 # here is where we check for the licenses the user already
1270 # accepted ... if we don't find a match, we make the user accept 1490 # accepted ... if we don't find a match, we make the user accept
1271 local shopts=$-
1272 local alic 1491 local alic
1273 set -o noglob #so that bash doesn't expand "*" 1492 eshopts_push -o noglob # so that bash doesn't expand "*"
1274 for alic in ${ACCEPT_LICENSE} ; do 1493 for alic in ${ACCEPT_LICENSE} ; do
1275 if [[ ${alic} == ${l} ]]; then 1494 if [[ ${alic} == ${l} ]]; then
1276 set +o noglob; set -${shopts} #reset old shell opts 1495 eshopts_pop
1277 return 0 1496 return 0
1278 fi 1497 fi
1279 done 1498 done
1280 set +o noglob; set -$shopts #reset old shell opts 1499 eshopts_pop
1500 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1281 1501
1282 local licmsg=$(emktemp) 1502 local licmsg=$(emktemp)
1283 cat <<-EOF > ${licmsg} 1503 cat <<-EOF > ${licmsg}
1284 ********************************************************** 1504 **********************************************************
1285 The following license outlines the terms of use of this 1505 The following license outlines the terms of use of this
1358 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1578 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1359 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1579 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1360 export CDROM_SET=-1 1580 export CDROM_SET=-1
1361 for f in ${CDROM_CHECK_1//:/ } ; do 1581 for f in ${CDROM_CHECK_1//:/ } ; do
1362 ((++CDROM_SET)) 1582 ((++CDROM_SET))
1363 [[ -e ${CD_ROOT}/${f} ]] && break 1583 [[ -e ${CDROM_ROOT}/${f} ]] && break
1364 done 1584 done
1365 export CDROM_MATCH=${f} 1585 export CDROM_MATCH=${f}
1366 return 1586 return
1367 fi 1587 fi
1368 1588
1532# of the lists. 1752# of the lists.
1533strip-linguas() { 1753strip-linguas() {
1534 local ls newls nols 1754 local ls newls nols
1535 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1755 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1536 local op=$1; shift 1756 local op=$1; shift
1537 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1757 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1538 local d f 1758 local d f
1539 for d in "$@" ; do 1759 for d in "$@" ; do
1540 if [[ ${op} == "-u" ]] ; then 1760 if [[ ${op} == "-u" ]] ; then
1541 newls=${ls} 1761 newls=${ls}
1542 else 1762 else
1543 newls="" 1763 newls=""
1544 fi 1764 fi
1545 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1765 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1546 if [[ ${op} == "-i" ]] ; then 1766 if [[ ${op} == "-i" ]] ; then
1547 hasq ${f} ${ls} && newls="${newls} ${f}" 1767 has ${f} ${ls} && newls="${newls} ${f}"
1548 else 1768 else
1549 hasq ${f} ${ls} || newls="${newls} ${f}" 1769 has ${f} ${ls} || newls="${newls} ${f}"
1550 fi 1770 fi
1551 done 1771 done
1552 ls=${newls} 1772 ls=${newls}
1553 done 1773 done
1554 else 1774 else
1556 fi 1776 fi
1557 1777
1558 nols="" 1778 nols=""
1559 newls="" 1779 newls=""
1560 for f in ${LINGUAS} ; do 1780 for f in ${LINGUAS} ; do
1561 if hasq ${f} ${ls} ; then 1781 if has ${f} ${ls} ; then
1562 newls="${newls} ${f}" 1782 newls="${newls} ${f}"
1563 else 1783 else
1564 nols="${nols} ${f}" 1784 nols="${nols} ${f}"
1565 fi 1785 fi
1566 done 1786 done
1567 [[ -n ${nols} ]] \ 1787 [[ -n ${nols} ]] \
1568 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1788 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1569 export LINGUAS=${newls:1} 1789 export LINGUAS=${newls:1}
1570} 1790}
1571 1791
1572# @FUNCTION: preserve_old_lib 1792# @FUNCTION: preserve_old_lib
1573# @USAGE: <libs to preserve> [more libs] 1793# @USAGE: <libs to preserve> [more libs]
1583 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1803 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1584 die "Invalid preserve_old_lib() usage" 1804 die "Invalid preserve_old_lib() usage"
1585 fi 1805 fi
1586 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1806 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1587 1807
1808 # let portage worry about it
1809 has preserve-libs ${FEATURES} && return 0
1810
1588 local lib dir 1811 local lib dir
1589 for lib in "$@" ; do 1812 for lib in "$@" ; do
1590 [[ -e ${ROOT}/${lib} ]] || continue 1813 [[ -e ${ROOT}/${lib} ]] || continue
1591 dir=${lib%/*} 1814 dir=${lib%/*}
1592 dodir ${dir} || die "dodir ${dir} failed" 1815 dodir ${dir} || die "dodir ${dir} failed"
1602preserve_old_lib_notify() { 1825preserve_old_lib_notify() {
1603 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1826 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1604 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1827 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1605 die "Invalid preserve_old_lib_notify() usage" 1828 die "Invalid preserve_old_lib_notify() usage"
1606 fi 1829 fi
1830
1831 # let portage worry about it
1832 has preserve-libs ${FEATURES} && return 0
1607 1833
1608 local lib notice=0 1834 local lib notice=0
1609 for lib in "$@" ; do 1835 for lib in "$@" ; do
1610 [[ -e ${ROOT}/${lib} ]] || continue 1836 [[ -e ${ROOT}/${lib} ]] || continue
1611 if [[ ${notice} -eq 0 ]] ; then 1837 if [[ ${notice} -eq 0 ]] ; then
1615 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1841 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1616 ewarn "in order to remove these old dependencies. If you do not have this" 1842 ewarn "in order to remove these old dependencies. If you do not have this"
1617 ewarn "helper program, simply emerge the 'gentoolkit' package." 1843 ewarn "helper program, simply emerge the 'gentoolkit' package."
1618 ewarn 1844 ewarn
1619 fi 1845 fi
1846 # temp hack for #348634 #357225
1847 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1620 ewarn " # revdep-rebuild --library ${lib##*/}" 1848 ewarn " # revdep-rebuild --library '${lib}'"
1621 done 1849 done
1622 if [[ ${notice} -eq 1 ]] ; then 1850 if [[ ${notice} -eq 1 ]] ; then
1623 ewarn 1851 ewarn
1624 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1852 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1625 ewarn "delete the old libraries." 1853 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1854 for lib in "$@" ; do
1855 ewarn " # rm '${lib}'"
1856 done
1626 fi 1857 fi
1627} 1858}
1628 1859
1629# @FUNCTION: built_with_use 1860# @FUNCTION: built_with_use
1630# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1861# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1631# @DESCRIPTION: 1862# @DESCRIPTION:
1863#
1864# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1865#
1632# A temporary hack until portage properly supports DEPENDing on USE 1866# A temporary hack until portage properly supports DEPENDing on USE
1633# flags being enabled in packages. This will check to see if the specified 1867# flags being enabled in packages. This will check to see if the specified
1634# DEPEND atom was built with the specified list of USE flags. The 1868# DEPEND atom was built with the specified list of USE flags. The
1635# --missing option controls the behavior if called on a package that does 1869# --missing option controls the behavior if called on a package that does
1636# not actually support the defined USE flags (aka listed in IUSE). 1870# not actually support the defined USE flags (aka listed in IUSE).
1637# The default is to abort (call die). The -a and -o flags control 1871# The default is to abort (call die). The -a and -o flags control
1638# the requirements of the USE flags. They correspond to "and" and "or" 1872# the requirements of the USE flags. They correspond to "and" and "or"
1639# logic. So the -a flag means all listed USE flags must be enabled 1873# logic. So the -a flag means all listed USE flags must be enabled
1640# while the -o flag means at least one of the listed fIUSE flags must be 1874# while the -o flag means at least one of the listed IUSE flags must be
1641# enabled. The --hidden option is really for internal use only as it 1875# enabled. The --hidden option is really for internal use only as it
1642# means the USE flag we're checking is hidden expanded, so it won't be found 1876# means the USE flag we're checking is hidden expanded, so it won't be found
1643# in IUSE like normal USE flags. 1877# in IUSE like normal USE flags.
1644# 1878#
1645# Remember that this function isn't terribly intelligent so order of optional 1879# Remember that this function isn't terribly intelligent so order of optional
1680 die) die "Unable to determine what USE flags $PKG was built with";; 1914 die) die "Unable to determine what USE flags $PKG was built with";;
1681 esac 1915 esac
1682 fi 1916 fi
1683 1917
1684 if [[ ${hidden} == "no" ]] ; then 1918 if [[ ${hidden} == "no" ]] ; then
1685 local IUSE_BUILT=$(<${IUSEFILE}) 1919 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1686 # Don't check USE_EXPAND #147237 1920 # Don't check USE_EXPAND #147237
1687 local expand 1921 local expand
1688 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1922 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1689 if [[ $1 == ${expand}_* ]] ; then 1923 if [[ $1 == ${expand}_* ]] ; then
1690 expand="" 1924 expand=""
1691 break 1925 break
1692 fi 1926 fi
1693 done 1927 done
1694 if [[ -n ${expand} ]] ; then 1928 if [[ -n ${expand} ]] ; then
1695 if ! has $1 ${IUSE_BUILT} ; then 1929 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1696 case ${missing_action} in 1930 case ${missing_action} in
1697 true) return 0;; 1931 true) return 0;;
1698 false) return 1;; 1932 false) return 1;;
1699 die) die "$PKG does not actually support the $1 USE flag!";; 1933 die) die "$PKG does not actually support the $1 USE flag!";;
1700 esac 1934 esac
1764 ) || die 1998 ) || die
1765 else 1999 else
1766 newbin "${tmpwrapper}" "${wrapper}" || die 2000 newbin "${tmpwrapper}" "${wrapper}" || die
1767 fi 2001 fi
1768} 2002}
2003
2004# @FUNCTION: path_exists
2005# @USAGE: [-a|-o] <paths>
2006# @DESCRIPTION:
2007# Check if the specified paths exist. Works for all types of paths
2008# (files/dirs/etc...). The -a and -o flags control the requirements
2009# of the paths. They correspond to "and" and "or" logic. So the -a
2010# flag means all the paths must exist while the -o flag means at least
2011# one of the paths must exist. The default behavior is "and". If no
2012# paths are specified, then the return value is "false".
2013path_exists() {
2014 local opt=$1
2015 [[ ${opt} == -[ao] ]] && shift || opt="-a"
2016
2017 # no paths -> return false
2018 # same behavior as: [[ -e "" ]]
2019 [[ $# -eq 0 ]] && return 1
2020
2021 local p r=0
2022 for p in "$@" ; do
2023 [[ -e ${p} ]]
2024 : $(( r += $? ))
2025 done
2026
2027 case ${opt} in
2028 -a) return $(( r != 0 )) ;;
2029 -o) return $(( r == $# )) ;;
2030 esac
2031}
2032
2033# @FUNCTION: in_iuse
2034# @USAGE: <flag>
2035# @DESCRIPTION:
2036# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
2037# as necessary.
2038#
2039# Note that this function should not be used in the global scope.
2040in_iuse() {
2041 debug-print-function ${FUNCNAME} "${@}"
2042 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
2043
2044 local flag=${1}
2045 local liuse=( ${IUSE} )
2046
2047 has "${flag}" "${liuse[@]#[+-]}"
2048}
2049
2050# @FUNCTION: usex
2051# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
2052# @DESCRIPTION:
2053# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
2054# otherwise echo [false output][false suffix] (defaults to "no").
2055usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963

Legend:
Removed from v.1.296  
changed lines
  Added in v.1.366

  ViewVC Help
Powered by ViewVC 1.1.20